{*******************************************************}
{                                                       }
{           CodeGear Delphi Runtime Library             }
{ Copyright(c) 2014 Embarcadero Technologies, Inc.      }
{                                                       }
{*******************************************************}

unit Androidapi.JNI.usbserial;

interface

uses
  Androidapi.JNIBridge,
  Androidapi.JNI.JavaTypes,
  Androidapi.JNI.GraphicsContentViewText,
  Androidapi.JNI.Util,
  Androidapi.JNI.Os,
  Androidapi.JNI.Net,
  Androidapi.JNI.App;

type
// ===== Forward declarations =====

  JUsbAccessory = interface;//android.hardware.usb.UsbAccessory
  JUsbDevice = interface;//android.hardware.usb.UsbDevice
  JUsbDeviceConnection = interface;//android.hardware.usb.UsbDeviceConnection
  JUsbEndpoint = interface;//android.hardware.usb.UsbEndpoint
  JUsbInterface = interface;//android.hardware.usb.UsbInterface
  JUsbManager = interface;//android.hardware.usb.UsbManager
  JUsbRequest = interface;//android.hardware.usb.UsbRequest
  JUsbSerialDriver = interface;//com.hoho.android.usbserial.driver.UsbSerialDriver
  JCdcAcmSerialDriver = interface;//com.hoho.android.usbserial.driver.CdcAcmSerialDriver
  JFtdiSerialDriver = interface;//com.hoho.android.usbserial.driver.FtdiSerialDriver
  JFtdiSerialDriver_DeviceType = interface;//com.hoho.android.usbserial.driver.FtdiSerialDriver$DeviceType
  JUsbId = interface;//com.hoho.android.usbserial.driver.UsbId
  JUsbSerialProber = interface;//com.hoho.android.usbserial.driver.UsbSerialProber
  JUsbSerialProber_1 = interface;//com.hoho.android.usbserial.driver.UsbSerialProber$1
  JUsbSerialProber_2 = interface;//com.hoho.android.usbserial.driver.UsbSerialProber$2
  JUsbSerialRuntimeException = interface;//com.hoho.android.usbserial.driver.UsbSerialRuntimeException
  JHexDump = interface;//com.hoho.android.usbserial.util.HexDump
  JSerialInputOutputManager = interface;//com.hoho.android.usbserial.util.SerialInputOutputManager
  JSerialInputOutputManager_Listener = interface;//com.hoho.android.usbserial.util.SerialInputOutputManager$Listener
  JSerialInputOutputManager_State = interface;//com.hoho.android.usbserial.util.SerialInputOutputManager$State

// ===== Interface declarations =====

  JUsbAccessoryClass = interface(JObjectClass)
    ['{1D9B9887-3355-48AD-9E48-30EA6B124537}']
    {class} function _GetCREATOR: JParcelable_Creator;
    {class} property CREATOR: JParcelable_Creator read _GetCREATOR;
  end;

  [JavaSignature('android/hardware/usb/UsbAccessory')]
  JUsbAccessory = interface(JObject)
    ['{083B13FB-2A1A-4659-BECD-9C245475B724}']
    function describeContents: Integer; cdecl;
    function equals(obj: JObject): Boolean; cdecl;
    function getDescription: JString; cdecl;
    function getManufacturer: JString; cdecl;
    function getModel: JString; cdecl;
    function getSerial: JString; cdecl;
    function getUri: JString; cdecl;
    function getVersion: JString; cdecl;
    function hashCode: Integer; cdecl;
    function toString: JString; cdecl;
    procedure writeToParcel(parcel: JParcel; flags: Integer); cdecl;
  end;
  TJUsbAccessory = class(TJavaGenericImport<JUsbAccessoryClass, JUsbAccessory>) end;

  JUsbDeviceClass = interface(JObjectClass)
    ['{23359F82-699F-48E1-B1DD-43DD18455D2D}']
    {class} function _GetCREATOR: JParcelable_Creator;
    {class} function getDeviceId(name: JString): Integer; cdecl; overload;
    {class} function getDeviceName(id: Integer): JString; cdecl; overload;
    {class} property CREATOR: JParcelable_Creator read _GetCREATOR;
  end;

  [JavaSignature('android/hardware/usb/UsbDevice')]
  JUsbDevice = interface(JObject)
    ['{EAD5113C-AC54-4131-BED2-46F449FFD4B7}']
    function describeContents: Integer; cdecl;
    function equals(o: JObject): Boolean; cdecl;
    function getDeviceClass: Integer; cdecl;
    function getDeviceId: Integer; cdecl; overload;
    function getDeviceName: JString; cdecl; overload;
    function getDeviceProtocol: Integer; cdecl;
    function getDeviceSubclass: Integer; cdecl;
    function getInterface(index: Integer): JUsbInterface; cdecl;
    function getInterfaceCount: Integer; cdecl;
    function getProductId: Integer; cdecl;
    function getVendorId: Integer; cdecl;
    function hashCode: Integer; cdecl;
    function toString: JString; cdecl;
    procedure writeToParcel(parcel: JParcel; flags: Integer); cdecl;
  end;
  TJUsbDevice = class(TJavaGenericImport<JUsbDeviceClass, JUsbDevice>) end;

  JUsbDeviceConnectionClass = interface(JObjectClass)
    ['{83888555-657F-42A1-9BC1-8B23E2F69899}']
  end;

  [JavaSignature('android/hardware/usb/UsbDeviceConnection')]
  JUsbDeviceConnection = interface(JObject)
    ['{6CC94621-8592-4C7F-B28A-2E644692B85A}']
    function bulkTransfer(endpoint: JUsbEndpoint; buffer: TJavaArray<Byte>; length: Integer; timeout: Integer): Integer; cdecl; overload;
    function bulkTransfer(endpoint: JUsbEndpoint; buffer: TJavaArray<Byte>; offset: Integer; length: Integer; timeout: Integer): Integer; cdecl; overload;
    function claimInterface(intf: JUsbInterface; force: Boolean): Boolean; cdecl;
    procedure close; cdecl;
    function controlTransfer(requestType: Integer; request: Integer; value: Integer; index: Integer; buffer: TJavaArray<Byte>; length: Integer; timeout: Integer): Integer; cdecl; overload;
    function controlTransfer(requestType: Integer; request: Integer; value: Integer; index: Integer; buffer: TJavaArray<Byte>; offset: Integer; length: Integer; timeout: Integer): Integer; cdecl; overload;
    function getFileDescriptor: Integer; cdecl;
    function getRawDescriptors: TJavaArray<Byte>; cdecl;
    function getSerial: JString; cdecl;
    function releaseInterface(intf: JUsbInterface): Boolean; cdecl;
    function requestWait: JUsbRequest; cdecl;
  end;
  TJUsbDeviceConnection = class(TJavaGenericImport<JUsbDeviceConnectionClass, JUsbDeviceConnection>) end;

  JUsbEndpointClass = interface(JObjectClass)
    ['{53DC559E-4126-4589-9CDF-681B6A461496}']
    {class} function _GetCREATOR: JParcelable_Creator;
    {class} property CREATOR: JParcelable_Creator read _GetCREATOR;
  end;

  [JavaSignature('android/hardware/usb/UsbEndpoint')]
  JUsbEndpoint = interface(JObject)
    ['{A9A1F612-B537-4C37-8523-1B7AEADB1D43}']
    function describeContents: Integer; cdecl;
    function getAddress: Integer; cdecl;
    function getAttributes: Integer; cdecl;
    function getDirection: Integer; cdecl;
    function getEndpointNumber: Integer; cdecl;
    function getInterval: Integer; cdecl;
    function getMaxPacketSize: Integer; cdecl;
    function getType: Integer; cdecl;
    function toString: JString; cdecl;
    procedure writeToParcel(parcel: JParcel; flags: Integer); cdecl;
  end;
  TJUsbEndpoint = class(TJavaGenericImport<JUsbEndpointClass, JUsbEndpoint>) end;

  JUsbInterfaceClass = interface(JObjectClass)
    ['{59313EE2-7603-4BBC-ACBC-4BC863D31B6C}']
    {class} function _GetCREATOR: JParcelable_Creator;
    {class} property CREATOR: JParcelable_Creator read _GetCREATOR;
  end;

  [JavaSignature('android/hardware/usb/UsbInterface')]
  JUsbInterface = interface(JObject)
    ['{026556E6-07DF-422D-AF28-BC06795B91E7}']
    function describeContents: Integer; cdecl;
    function getEndpoint(index: Integer): JUsbEndpoint; cdecl;
    function getEndpointCount: Integer; cdecl;
    function getId: Integer; cdecl;
    function getInterfaceClass: Integer; cdecl;
    function getInterfaceProtocol: Integer; cdecl;
    function getInterfaceSubclass: Integer; cdecl;
    function toString: JString; cdecl;
    procedure writeToParcel(parcel: JParcel; flags: Integer); cdecl;
  end;
  TJUsbInterface = class(TJavaGenericImport<JUsbInterfaceClass, JUsbInterface>) end;

  JUsbManagerClass = interface(JObjectClass)
    ['{1048A6E9-E1B5-4DA5-A168-ED91E8DE5284}']
    {class} function _GetACTION_USB_ACCESSORY_ATTACHED: JString;
    {class} function _GetACTION_USB_ACCESSORY_DETACHED: JString;
    {class} function _GetACTION_USB_DEVICE_ATTACHED: JString;
    {class} function _GetACTION_USB_DEVICE_DETACHED: JString;
    {class} function _GetEXTRA_ACCESSORY: JString;
    {class} function _GetEXTRA_DEVICE: JString;
    {class} function _GetEXTRA_PERMISSION_GRANTED: JString;
    {class} property ACTION_USB_ACCESSORY_ATTACHED: JString read _GetACTION_USB_ACCESSORY_ATTACHED;
    {class} property ACTION_USB_ACCESSORY_DETACHED: JString read _GetACTION_USB_ACCESSORY_DETACHED;
    {class} property ACTION_USB_DEVICE_ATTACHED: JString read _GetACTION_USB_DEVICE_ATTACHED;
    {class} property ACTION_USB_DEVICE_DETACHED: JString read _GetACTION_USB_DEVICE_DETACHED;
    {class} property EXTRA_ACCESSORY: JString read _GetEXTRA_ACCESSORY;
    {class} property EXTRA_DEVICE: JString read _GetEXTRA_DEVICE;
    {class} property EXTRA_PERMISSION_GRANTED: JString read _GetEXTRA_PERMISSION_GRANTED;
  end;

  [JavaSignature('android/hardware/usb/UsbManager')]
  JUsbManager = interface(JObject)
    ['{6F603A25-E816-4012-9B23-054B428A4A75}']
    function getAccessoryList: TJavaObjectArray<JUsbAccessory>; cdecl;
    function getDeviceList: JHashMap; cdecl;
    function hasPermission(device: JUsbDevice): Boolean; cdecl; overload;
    function hasPermission(accessory: JUsbAccessory): Boolean; cdecl; overload;
    function openAccessory(accessory: JUsbAccessory): JParcelFileDescriptor; cdecl;
    function openDevice(device: JUsbDevice): JUsbDeviceConnection; cdecl;
    procedure requestPermission(device: JUsbDevice; pi: JPendingIntent); cdecl; overload;
    procedure requestPermission(accessory: JUsbAccessory; pi: JPendingIntent); cdecl; overload;
  end;
  TJUsbManager = class(TJavaGenericImport<JUsbManagerClass, JUsbManager>) end;

  JUsbRequestClass = interface(JObjectClass)
    ['{8A8E6489-7B33-4CCC-B25E-2847FD29DA80}']
    {class} function init: JUsbRequest; cdecl;
  end;

  [JavaSignature('android/hardware/usb/UsbRequest')]
  JUsbRequest = interface(JObject)
    ['{C192EBAE-64F9-46FD-9E81-CB44E9D42FB1}']
    function cancel: Boolean; cdecl;
    procedure close; cdecl;
    function getClientData: JObject; cdecl;
    function getEndpoint: JUsbEndpoint; cdecl;
    function initialize(connection: JUsbDeviceConnection; endpoint: JUsbEndpoint): Boolean; cdecl;
    function queue(buffer: JByteBuffer; length: Integer): Boolean; cdecl;
    procedure setClientData(data: JObject); cdecl;
  end;
  TJUsbRequest = class(TJavaGenericImport<JUsbRequestClass, JUsbRequest>) end;

  JUsbSerialDriverClass = interface(JObjectClass)
    ['{B868EA10-19E0-4261-B77E-1ED6E12480AE}']
    {class} function _GetDEFAULT_READ_BUFFER_SIZE: Integer;
    {class} function _GetDEFAULT_WRITE_BUFFER_SIZE: Integer;
    {class} function init(P1: JUsbDevice; P2: JUsbDeviceConnection): JUsbSerialDriver; cdecl;
    {class} property DEFAULT_READ_BUFFER_SIZE: Integer read _GetDEFAULT_READ_BUFFER_SIZE;
    {class} property DEFAULT_WRITE_BUFFER_SIZE: Integer read _GetDEFAULT_WRITE_BUFFER_SIZE;
  end;

  [JavaSignature('com/hoho/android/usbserial/driver/UsbSerialDriver')]
  JUsbSerialDriver = interface(JObject)
    ['{1009AD24-5498-4557-BEFC-CC0ED4F637AF}']
    procedure close; cdecl;
    function getDevice: JUsbDevice; cdecl;
    procedure open; cdecl;
    function read(P1: TJavaArray<Byte>; P2: Integer): Integer; cdecl;
    function setBaudRate(P1: Integer): Integer; cdecl;
    procedure setReadBufferSize(P1: Integer); cdecl;
    procedure setWriteBufferSize(P1: Integer); cdecl;
    function write(P1: TJavaArray<Byte>; P2: Integer): Integer; cdecl;
  end;
  TJUsbSerialDriver = class(TJavaGenericImport<JUsbSerialDriverClass, JUsbSerialDriver>) end;

  JCdcAcmSerialDriverClass = interface(JUsbSerialDriverClass)
    ['{C69A2632-CB13-4B5C-9186-E9464B1C6FE3}']
    {class} function getSupportedDevices: JMap; cdecl;
    {class} function init(P1: JUsbDevice; P2: JUsbDeviceConnection): JCdcAcmSerialDriver; cdecl;
  end;

  [JavaSignature('com/hoho/android/usbserial/driver/CdcAcmSerialDriver')]
  JCdcAcmSerialDriver = interface(JUsbSerialDriver)
    ['{66F0D85C-A3D2-49DC-AE23-EE133396E60F}']
    procedure close; cdecl;
    procedure open; cdecl;
    function read(P1: TJavaArray<Byte>; P2: Integer): Integer; cdecl;
    function setBaudRate(P1: Integer): Integer; cdecl;
    function write(P1: TJavaArray<Byte>; P2: Integer): Integer; cdecl;
  end;
  TJCdcAcmSerialDriver = class(TJavaGenericImport<JCdcAcmSerialDriverClass, JCdcAcmSerialDriver>) end;

  JFtdiSerialDriverClass = interface(JUsbSerialDriverClass)
    ['{FBD8B4FC-D5AE-42CA-8786-5CAFD28CFD97}']
    {class} function _GetFTDI_DEVICE_IN_REQTYPE: Integer;
    {class} function _GetFTDI_DEVICE_OUT_REQTYPE: Integer;
    {class} function _GetUSB_ENDPOINT_IN: Integer;
    {class} function _GetUSB_ENDPOINT_OUT: Integer;
    {class} function _GetUSB_READ_TIMEOUT_MILLIS: Integer;
    {class} function _GetUSB_RECIP_DEVICE: Integer;
    {class} function _GetUSB_RECIP_ENDPOINT: Integer;
    {class} function _GetUSB_RECIP_INTERFACE: Integer;
    {class} function _GetUSB_RECIP_OTHER: Integer;
    {class} function _GetUSB_TYPE_CLASS: Integer;
    {class} function _GetUSB_TYPE_RESERVED: Integer;
    {class} function _GetUSB_TYPE_STANDARD: Integer;
    {class} function _GetUSB_TYPE_VENDOR: Integer;
    {class} function _GetUSB_WRITE_TIMEOUT_MILLIS: Integer;
    {class} function getSupportedDevices: JMap; cdecl;
    {class} function init(P1: JUsbDevice; P2: JUsbDeviceConnection): JFtdiSerialDriver; cdecl;
    {class} property FTDI_DEVICE_IN_REQTYPE: Integer read _GetFTDI_DEVICE_IN_REQTYPE;
    {class} property FTDI_DEVICE_OUT_REQTYPE: Integer read _GetFTDI_DEVICE_OUT_REQTYPE;
    {class} property USB_ENDPOINT_IN: Integer read _GetUSB_ENDPOINT_IN;
    {class} property USB_ENDPOINT_OUT: Integer read _GetUSB_ENDPOINT_OUT;
    {class} property USB_READ_TIMEOUT_MILLIS: Integer read _GetUSB_READ_TIMEOUT_MILLIS;
    {class} property USB_RECIP_DEVICE: Integer read _GetUSB_RECIP_DEVICE;
    {class} property USB_RECIP_ENDPOINT: Integer read _GetUSB_RECIP_ENDPOINT;
    {class} property USB_RECIP_INTERFACE: Integer read _GetUSB_RECIP_INTERFACE;
    {class} property USB_RECIP_OTHER: Integer read _GetUSB_RECIP_OTHER;
    {class} property USB_TYPE_CLASS: Integer read _GetUSB_TYPE_CLASS;
    {class} property USB_TYPE_RESERVED: Integer read _GetUSB_TYPE_RESERVED;
    {class} property USB_TYPE_STANDARD: Integer read _GetUSB_TYPE_STANDARD;
    {class} property USB_TYPE_VENDOR: Integer read _GetUSB_TYPE_VENDOR;
    {class} property USB_WRITE_TIMEOUT_MILLIS: Integer read _GetUSB_WRITE_TIMEOUT_MILLIS;
  end;

  [JavaSignature('com/hoho/android/usbserial/driver/FtdiSerialDriver')]
  JFtdiSerialDriver = interface(JUsbSerialDriver)
    ['{19AFBB7E-7D46-4203-B3B5-378D21F857F7}']
    procedure close; cdecl;
    procedure open; cdecl;
    function read(P1: TJavaArray<Byte>; P2: Integer): Integer; cdecl;
    procedure reset; cdecl;
    function setBaudRate(P1: Integer): Integer; cdecl;
    function write(P1: TJavaArray<Byte>; P2: Integer): Integer; cdecl;
  end;
  TJFtdiSerialDriver = class(TJavaGenericImport<JFtdiSerialDriverClass, JFtdiSerialDriver>) end;

  JFtdiSerialDriver_DeviceTypeClass = interface(JEnumClass)
    ['{3EA00082-444A-42E2-9D9C-C7818A99C76A}']
    {class} function _GetTYPE_2232C: JFtdiSerialDriver_DeviceType;
    {class} function _GetTYPE_2232H: JFtdiSerialDriver_DeviceType;
    {class} function _GetTYPE_4232H: JFtdiSerialDriver_DeviceType;
    {class} function _GetTYPE_AM: JFtdiSerialDriver_DeviceType;
    {class} function _GetTYPE_BM: JFtdiSerialDriver_DeviceType;
    {class} function _GetTYPE_R: JFtdiSerialDriver_DeviceType;
    {class} function valueOf(P1: JString): JFtdiSerialDriver_DeviceType; cdecl;
    {class} function values: TJavaObjectArray<JFtdiSerialDriver_DeviceType>; cdecl;
    {class} property TYPE_2232C: JFtdiSerialDriver_DeviceType read _GetTYPE_2232C;
    {class} property TYPE_2232H: JFtdiSerialDriver_DeviceType read _GetTYPE_2232H;
    {class} property TYPE_4232H: JFtdiSerialDriver_DeviceType read _GetTYPE_4232H;
    {class} property TYPE_AM: JFtdiSerialDriver_DeviceType read _GetTYPE_AM;
    {class} property TYPE_BM: JFtdiSerialDriver_DeviceType read _GetTYPE_BM;
    {class} property TYPE_R: JFtdiSerialDriver_DeviceType read _GetTYPE_R;
  end;

  [JavaSignature('com/hoho/android/usbserial/driver/FtdiSerialDriver$DeviceType')]
  JFtdiSerialDriver_DeviceType = interface(JEnum)
    ['{15F8C6B4-2123-421C-910C-1F47250E0E62}']
  end;
  TJFtdiSerialDriver_DeviceType = class(TJavaGenericImport<JFtdiSerialDriver_DeviceTypeClass, JFtdiSerialDriver_DeviceType>) end;

  JUsbIdClass = interface(JObjectClass)
    ['{1B728BB9-7E72-4F73-B84D-AB314519CFBE}']
    {class} function _GetARDUINO_LEONARDO: Integer;
    {class} function _GetARDUINO_MEGA_2560: Integer;
    {class} function _GetARDUINO_MEGA_2560_R3: Integer;
    {class} function _GetARDUINO_MEGA_ADK: Integer;
    {class} function _GetARDUINO_MEGA_ADK_R3: Integer;
    {class} function _GetARDUINO_SERIAL_ADAPTER: Integer;
    {class} function _GetARDUINO_SERIAL_ADAPTER_R3: Integer;
    {class} function _GetARDUINO_UNO: Integer;
    {class} function _GetARDUINO_UNO_R3: Integer;
    {class} function _GetFTDI_FT232R: Integer;
    {class} function _GetVAN_OOIJEN_TECH_TEENSYDUINO_SERIAL: Integer;
    {class} function _GetVENDOR_ARDUINO: Integer;
    {class} function _GetVENDOR_FTDI: Integer;
    {class} function _GetVENDOR_VAN_OOIJEN_TECH: Integer;
    {class} property ARDUINO_LEONARDO: Integer read _GetARDUINO_LEONARDO;
    {class} property ARDUINO_MEGA_2560: Integer read _GetARDUINO_MEGA_2560;
    {class} property ARDUINO_MEGA_2560_R3: Integer read _GetARDUINO_MEGA_2560_R3;
    {class} property ARDUINO_MEGA_ADK: Integer read _GetARDUINO_MEGA_ADK;
    {class} property ARDUINO_MEGA_ADK_R3: Integer read _GetARDUINO_MEGA_ADK_R3;
    {class} property ARDUINO_SERIAL_ADAPTER: Integer read _GetARDUINO_SERIAL_ADAPTER;
    {class} property ARDUINO_SERIAL_ADAPTER_R3: Integer read _GetARDUINO_SERIAL_ADAPTER_R3;
    {class} property ARDUINO_UNO: Integer read _GetARDUINO_UNO;
    {class} property ARDUINO_UNO_R3: Integer read _GetARDUINO_UNO_R3;
    {class} property FTDI_FT232R: Integer read _GetFTDI_FT232R;
    {class} property VAN_OOIJEN_TECH_TEENSYDUINO_SERIAL: Integer read _GetVAN_OOIJEN_TECH_TEENSYDUINO_SERIAL;
    {class} property VENDOR_ARDUINO: Integer read _GetVENDOR_ARDUINO;
    {class} property VENDOR_FTDI: Integer read _GetVENDOR_FTDI;
    {class} property VENDOR_VAN_OOIJEN_TECH: Integer read _GetVENDOR_VAN_OOIJEN_TECH;
  end;

  [JavaSignature('com/hoho/android/usbserial/driver/UsbId')]
  JUsbId = interface(JObject)
    ['{BAE40FCC-18D3-4A00-A476-0B07BF10151B}']
  end;
  TJUsbId = class(TJavaGenericImport<JUsbIdClass, JUsbId>) end;

  JUsbSerialProberClass = interface(JEnumClass)
    ['{CA8780F6-54F4-4939-ACEA-67DAF6077068}']
    {class} function _GetCDC_ACM_SERIAL: JUsbSerialProber;
    {class} function _GetFTDI_SERIAL: JUsbSerialProber;
    {class} function acquire(P1: JUsbManager): JUsbSerialDriver; cdecl; overload;
    {class} function acquire(P1: JUsbManager; P2: JUsbDevice): JUsbSerialDriver; cdecl; overload;
    {class} function valueOf(P1: JString): JUsbSerialProber; cdecl;
    {class} function values: TJavaObjectArray<JUsbSerialProber>; cdecl;
    {class} property CDC_ACM_SERIAL: JUsbSerialProber read _GetCDC_ACM_SERIAL;
    {class} property FTDI_SERIAL: JUsbSerialProber read _GetFTDI_SERIAL;
  end;

  [JavaSignature('com/hoho/android/usbserial/driver/UsbSerialProber')]
  JUsbSerialProber = interface(JEnum)
    ['{BF1D1877-B483-483A-8BB9-8EEED0C9E760}']
    function getDevice(P1: JUsbManager; P2: JUsbDevice): JUsbSerialDriver; cdecl;
  end;
  TJUsbSerialProber = class(TJavaGenericImport<JUsbSerialProberClass, JUsbSerialProber>) end;

  JUsbSerialProber_1Class = interface(JUsbSerialProberClass)
    ['{DB6CE9D3-58DE-46F2-90DB-3C9FC0D69943}']
  end;

  [JavaSignature('com/hoho/android/usbserial/driver/UsbSerialProber$1')]
  JUsbSerialProber_1 = interface(JUsbSerialProber)
    ['{E1AFADF0-39C8-4243-AD71-69E15BAE6308}']
    function getDevice(P1: JUsbManager; P2: JUsbDevice): JUsbSerialDriver; cdecl;
  end;
  TJUsbSerialProber_1 = class(TJavaGenericImport<JUsbSerialProber_1Class, JUsbSerialProber_1>) end;

  JUsbSerialProber_2Class = interface(JUsbSerialProberClass)
    ['{B14C431D-6248-4B85-A04D-94E2C8CE0C01}']
  end;

  [JavaSignature('com/hoho/android/usbserial/driver/UsbSerialProber$2')]
  JUsbSerialProber_2 = interface(JUsbSerialProber)
    ['{3778A992-5630-480B-801C-F4848DF055C0}']
    function getDevice(P1: JUsbManager; P2: JUsbDevice): JUsbSerialDriver; cdecl;
  end;
  TJUsbSerialProber_2 = class(TJavaGenericImport<JUsbSerialProber_2Class, JUsbSerialProber_2>) end;

  JUsbSerialRuntimeExceptionClass = interface(JRuntimeExceptionClass)
    ['{19AAD6C2-B713-42C1-8B94-4BB23225C96C}']
    {class} function init: JUsbSerialRuntimeException; cdecl; overload;
    {class} function init(P1: JString): JUsbSerialRuntimeException; cdecl; overload;
    {class} function init(P1: JThrowable): JUsbSerialRuntimeException; cdecl; overload;
    {class} function init(P1: JString; P2: JThrowable): JUsbSerialRuntimeException; cdecl; overload;
  end;

  [JavaSignature('com/hoho/android/usbserial/driver/UsbSerialRuntimeException')]
  JUsbSerialRuntimeException = interface(JRuntimeException)
    ['{B7F918A7-5FC5-455A-ACCA-C69FA550486B}']
  end;
  TJUsbSerialRuntimeException = class(TJavaGenericImport<JUsbSerialRuntimeExceptionClass, JUsbSerialRuntimeException>) end;

  JHexDumpClass = interface(JObjectClass)
    ['{D1C7BC19-408B-4DF3-A0D0-B55392E2BAA4}']
    {class} function dumpHexString(P1: TJavaArray<Byte>): JString; cdecl; overload;
    {class} function dumpHexString(P1: TJavaArray<Byte>; P2: Integer; P3: Integer): JString; cdecl; overload;
    {class} function hexStringToByteArray(P1: JString): TJavaArray<Byte>; cdecl;
    {class} function init: JHexDump; cdecl;
    {class} function toByteArray(P1: Byte): TJavaArray<Byte>; cdecl; overload;
    {class} function toByteArray(P1: Integer): TJavaArray<Byte>; cdecl; overload;
    {class} function toHexString(P1: Integer): JString; cdecl; overload;
    {class} function toHexString(P1: Byte): JString; cdecl; overload;
    {class} function toHexString(P1: TJavaArray<Byte>): JString; cdecl; overload;
    {class} function toHexString(P1: TJavaArray<Byte>; P2: Integer; P3: Integer): JString; cdecl; overload;
  end;

  [JavaSignature('com/hoho/android/usbserial/util/HexDump')]
  JHexDump = interface(JObject)
    ['{2F844437-503B-4468-ACA0-F0A34178D960}']
  end;
  TJHexDump = class(TJavaGenericImport<JHexDumpClass, JHexDump>) end;

  JSerialInputOutputManagerClass = interface(JObjectClass)
    ['{775EB4B8-19B9-425F-AA8D-F132DB81BC12}']
    {class} function init(P1: JUsbSerialDriver): JSerialInputOutputManager; cdecl; overload;
    {class} function init(P1: JUsbSerialDriver; P2: JSerialInputOutputManager_Listener): JSerialInputOutputManager; cdecl; overload;
  end;

  [JavaSignature('com/hoho/android/usbserial/util/SerialInputOutputManager')]
  JSerialInputOutputManager = interface(JObject)
    ['{5340DA1F-883D-4DE4-864A-8DB79D1E3748}']
    function getListener: JSerialInputOutputManager_Listener; cdecl;
    procedure run; cdecl;
    procedure setListener(P1: JSerialInputOutputManager_Listener); cdecl;
    procedure stop; cdecl;
    procedure writeAsync(P1: TJavaArray<Byte>); cdecl;
  end;
  TJSerialInputOutputManager = class(TJavaGenericImport<JSerialInputOutputManagerClass, JSerialInputOutputManager>) end;

  JSerialInputOutputManager_ListenerClass = interface(IJavaClass)
    ['{AED13AC6-F815-4E5A-8A6D-507A1FC2E724}']
  end;

  [JavaSignature('com/hoho/android/usbserial/util/SerialInputOutputManager$Listener')]
  JSerialInputOutputManager_Listener = interface(IJavaInstance)
    ['{780568BE-E96B-403C-ACB1-A99ED523CBD5}']
    procedure onNewData(P1: TJavaArray<Byte>); cdecl;
    procedure onRunError(P1: JException); cdecl;
  end;
  TJSerialInputOutputManager_Listener = class(TJavaGenericImport<JSerialInputOutputManager_ListenerClass, JSerialInputOutputManager_Listener>) end;

  JSerialInputOutputManager_StateClass = interface(JEnumClass)
    ['{DC011D49-15DB-4BB1-8B29-18C96149D373}']
    {class} function _GetRUNNING: JSerialInputOutputManager_State;
    {class} function _GetSTOPPED: JSerialInputOutputManager_State;
    {class} function _GetSTOPPING: JSerialInputOutputManager_State;
    {class} function valueOf(P1: JString): JSerialInputOutputManager_State; cdecl;
    {class} function values: TJavaObjectArray<JSerialInputOutputManager_State>; cdecl;
    {class} property RUNNING: JSerialInputOutputManager_State read _GetRUNNING;
    {class} property STOPPED: JSerialInputOutputManager_State read _GetSTOPPED;
    {class} property STOPPING: JSerialInputOutputManager_State read _GetSTOPPING;
  end;

  [JavaSignature('com/hoho/android/usbserial/util/SerialInputOutputManager$State')]
  JSerialInputOutputManager_State = interface(JEnum)
    ['{151CFCBF-FC03-4DF7-A3FB-9B5C6C641B2D}']
  end;
  TJSerialInputOutputManager_State = class(TJavaGenericImport<JSerialInputOutputManager_StateClass, JSerialInputOutputManager_State>) end;

implementation

procedure RegisterTypes;
begin
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbAccessory', TypeInfo(Androidapi.JNI.usbserial.JUsbAccessory));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbDevice', TypeInfo(Androidapi.JNI.usbserial.JUsbDevice));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbDeviceConnection', TypeInfo(Androidapi.JNI.usbserial.JUsbDeviceConnection));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbEndpoint', TypeInfo(Androidapi.JNI.usbserial.JUsbEndpoint));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbInterface', TypeInfo(Androidapi.JNI.usbserial.JUsbInterface));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbManager', TypeInfo(Androidapi.JNI.usbserial.JUsbManager));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbRequest', TypeInfo(Androidapi.JNI.usbserial.JUsbRequest));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbSerialDriver', TypeInfo(Androidapi.JNI.usbserial.JUsbSerialDriver));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JCdcAcmSerialDriver', TypeInfo(Androidapi.JNI.usbserial.JCdcAcmSerialDriver));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JFtdiSerialDriver', TypeInfo(Androidapi.JNI.usbserial.JFtdiSerialDriver));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JFtdiSerialDriver_DeviceType', TypeInfo(Androidapi.JNI.usbserial.JFtdiSerialDriver_DeviceType));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbId', TypeInfo(Androidapi.JNI.usbserial.JUsbId));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbSerialProber', TypeInfo(Androidapi.JNI.usbserial.JUsbSerialProber));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbSerialProber_1', TypeInfo(Androidapi.JNI.usbserial.JUsbSerialProber_1));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbSerialProber_2', TypeInfo(Androidapi.JNI.usbserial.JUsbSerialProber_2));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JUsbSerialRuntimeException', TypeInfo(Androidapi.JNI.usbserial.JUsbSerialRuntimeException));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JHexDump', TypeInfo(Androidapi.JNI.usbserial.JHexDump));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JSerialInputOutputManager', TypeInfo(Androidapi.JNI.usbserial.JSerialInputOutputManager));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JSerialInputOutputManager_Listener', TypeInfo(Androidapi.JNI.usbserial.JSerialInputOutputManager_Listener));
  TRegTypes.RegisterType('Androidapi.JNI.usbserial.JSerialInputOutputManager_State', TypeInfo(Androidapi.JNI.usbserial.JSerialInputOutputManager_State));
end;

initialization
  RegisterTypes;
end.


