unit HeaderFooterTemplate;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Graphics, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.StdCtrls;

type
  THeaderFooterForm = class(TForm)
    Header: TToolBar;
    Footer: TToolBar;
    HeaderLabel: TLabel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  HeaderFooterForm: THeaderFooterForm;

implementation
uses
  Androidapi.JNI.GraphicsContentViewText, Androidapi.Helpers, FMX.Helpers.Android,  Androidapi.JNIBridge,
  Androidapi.JNI.usbserial, Androidapi.JNI.JavaTypes;

{$R *.fmx}


function SharedUSBManager: JUsbManager;
var
  USBManagerService: JObject;
begin
  USBManagerService := SharedActivityContext.getSystemService(TJContext.JavaClass.USB_SERVICE);
  Result := TJUsbManager.Wrap((USBManagerService as ILocalObject).GetObjectID);
end;

procedure THeaderFooterForm.Button1Click(Sender: TObject);
var
  USBManager: JUsbManager;
  UsbSerialDriver: TJUsbSerialProber;
  Driver: JUsbSerialDriver;
  TempArray: TJavaArray<Byte>;
begin
  USBManager := SharedUSBManager;

  // Find the first available driver.
  Driver := TJUsbSerialProber.JavaClass.acquire(USBManager);

  if (Driver <> nil) then
  begin
    Driver.open;
    try
      Driver.setBaudRate(115200);
      TempArray := TJavaArray<Byte>.Create(10);
      driver.write(TempArray, 10);

{      byte buffer[] = new byte[16];
      int numBytesRead = driver.read(buffer, 1000);
      Log.d(TAG, "Read " + numBytesRead + " bytes.");}
    finally
      Driver.Close;
    end;
  end;

end;

end.
